// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OWCSSSelector.h"

#import "OWSGMLTag.h"

#import <Foundation/Foundation.h>
#import <OmniBase/OmniBase.h>

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OWF/CSS.subproj/OWCSSSelector.m,v 1.9 2000/10/27 19:23:22 wiml Exp $")

@implementation OWCSSSelector

-init;
{
    if (! [super init])
        return nil;    
    tagName = @"";
    className = @"";
    IDName = @"";
    pseudoClassName = @"";
    return self;
}

- (void) dealloc;
{
    [tagName release];
    [className release];
    [IDName release];
    [pseudoClassName release];
    [super dealloc];
}

-(void)setTagName:(NSString *)newName;
{
    [tagName release];
    tagName = [newName copy];
}

-(void)setClassName:(NSString *)newName;
{
    [className release];
    className = [newName copy];
}

-(void)setIDName:(NSString *)newName;
{
    [IDName release];
    IDName = [newName copy];
}

-(void)setPseudoClassName:(NSString *)newName;
{
    [pseudoClassName release];
    pseudoClassName = [newName copy];
}

-(NSString *)tagName;
{
    return tagName;
}

-(NSString *)className;
{
    return className;
}

-(NSString *)IDName;
{
    return IDName;
}

-(NSString *)pseudoClassName;
{
    return pseudoClassName;
}

-(BOOL)isEqual:(OWCSSSelector *)selector;
{
    if (! [[selector tagName] isEqualToString:tagName]) {
        return NO;
    }
    if (! [[selector className] isEqualToString:className]) {
        return NO;
    }
    if (! [[selector IDName] isEqualToString:IDName]) {
        return NO;
    }
    if (! [[selector pseudoClassName] isEqualToString:pseudoClassName]) {
        return NO;
    }
    return YES;
}

-(BOOL)matchesTag:(OWSGMLTag *)tag;
{
    if (![tagName isEqualToString:@""]) {
        if (![tagName isEqualToString:[tag name]]) {
            return NO;
        }
    }
    if (![className isEqualToString:@""]) {
        if (![className isEqualToString:[tag valueForAttribute:@"class"]]) {
            return NO;
        }
    }
    if (![IDName isEqualToString:@""]) {
        if (![IDName isEqualToString:[tag valueForAttribute:@"id"]]) {
            return NO;
        }
    }
    if (![pseudoClassName isEqualToString:@""]) {
        return NO;
    }
    return YES;
}

#if 0
-(NSString *)description;
{
    return [NSString stringWithFormat:@"{\n\ttagName = '%@'\n\tclassName = '%@'\n\tIDName = '%@'\n}\n", tagName, className, IDName];
}
#endif

- (NSMutableDictionary *)debugDictionary;
{
    NSMutableDictionary *debugDictionary;

    debugDictionary = [super debugDictionary];

    if(tagName)
        [debugDictionary setObject:tagName forKey:@"tagName"];
    if(className)
        [debugDictionary setObject:className forKey:@"className"];
    if(IDName)
        [debugDictionary setObject:IDName forKey:@"IDName"];

    return debugDictionary;
}


@end
