// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OWCSSSelectorGroup.h"

#import <Foundation/Foundation.h>
#import <OmniBase/OmniBase.h>

#import "OWCSSSelector.h"

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OWF/CSS.subproj/OWCSSSelectorGroup.m,v 1.10 2000/10/30 23:42:30 kc Exp $")

@implementation OWCSSSelectorGroup

- initWithSelectorList:(NSArray *)newList withDeclarations:(NSDictionary *)newDeclarations;
{
    if (![super init])
        return nil;
    selectorList = [newList retain];
    declarations = [newDeclarations retain];
    return self;
}

- init;
{
    OBRejectUnusedImplementation(self, _cmd);
    return nil;
}

- (void)dealloc;
{
    [selectorList release];
    [declarations release];
    [super dealloc];
}

- (OWCSSSelector *)lastSelector;
{
    return [selectorList lastObject];
}

- (NSArray *)selectorList;
{
    return selectorList;
}

- (NSDictionary *)declarations;
{
    return declarations;
}

- (unsigned int)score;
{
#warning incorrect; the score is more complex than this. consult spec.
    return [selectorList count];
}

- (unsigned int)count;
{
    return [selectorList count];
}

- (NSMutableDictionary *)debugDictionary;
{
    NSMutableDictionary *debugDictionary;

    debugDictionary = [super debugDictionary];

    [debugDictionary setObject:selectorList forKey:@"selectorList"];
    [debugDictionary setObject:declarations forKey:@"declarations"];

    return debugDictionary;
}


@end
